<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'externalCriteria' => '\\StructType\\ExternalCriteria',
            'substrate' => '\\StructType\\Substrate',
            'dimensionedExternalProduct' => '\\StructType\\DimensionedExternalProduct',
            'externalProduct' => '\\StructType\\ExternalProduct',
            'dimension' => '\\StructType\\Dimension',
            'complexDescription' => '\\StructType\\ComplexDescription',
            'externalProductAttributeGroup' => '\\StructType\\ExternalProductAttributeGroup',
            'externalProductAttribute' => '\\StructType\\ExternalProductAttribute',
            'externalProductGroup' => '\\StructType\\ExternalProductGroup',
            'externalProductType' => '\\StructType\\ExternalProductType',
            'externalProductTypeDef' => '\\StructType\\ExternalProductTypeDef',
            'priceData' => '\\StructType\\PriceData',
            'externalPromo' => '\\StructType\\ExternalPromo',
            'externalCriteriaGroup' => '\\StructType\\ExternalCriteriaGroup',
            'externalPriceTable' => '\\StructType\\ExternalPriceTable',
            'priceMapping' => '\\StructType\\PriceMapping',
            'sku' => '\\StructType\\Sku',
            'externalUser' => '\\StructType\\ExternalUser',
            'templateVariableValue' => '\\StructType\\TemplateVariableValue',
            'giftData' => '\\StructType\\GiftData',
            'externalOrderConfirmation' => '\\StructType\\ExternalOrderConfirmation',
            'matBoard' => '\\StructType\\MatBoard',
            'mat' => '\\StructType\\Mat',
            'fillet' => '\\StructType\\Fillet',
            'frame' => '\\StructType\\Frame',
            'oversizedFee' => '\\StructType\\OversizedFee',
            'vGroove' => '\\StructType\\VGroove',
            'customProduct' => '\\StructType\\CustomProduct',
            'paymentMethod' => '\\StructType\\PaymentMethod',
            'externalProductPackage' => '\\StructType\\ExternalProductPackage',
            'fee' => '\\StructType\\Fee',
            'packagePriceData' => '\\StructType\\PackagePriceData',
            'glazing' => '\\StructType\\Glazing',
            'boardPackage' => '\\StructType\\BoardPackage',
            'framePackage' => '\\StructType\\FramePackage',
            'backing' => '\\StructType\\Backing',
            'board' => '\\StructType\\Board',
            'finishKit' => '\\StructType\\FinishKit',
            'finishingOption' => '\\StructType\\FinishingOption',
            'floatMount' => '\\StructType\\FloatMount',
            'image' => '\\StructType\\Image',
            'externalMedia' => '\\StructType\\ExternalMedia',
            'printJob' => '\\StructType\\PrintJob',
            'template' => '\\StructType\\Template',
            'templateVariable' => '\\StructType\\TemplateVariable',
            'liner' => '\\StructType\\Liner',
            'mountBoard' => '\\StructType\\MountBoard',
            'nameplate' => '\\StructType\\Nameplate',
            'raisedMat' => '\\StructType\\RaisedMat',
            'reverseBevelCut' => '\\StructType\\ReverseBevelCut',
            'channel' => '\\StructType\\Channel',
            'giftCertificate' => '\\StructType\\GiftCertificate',
            'giftCard' => '\\StructType\\GiftCard',
            'printOnlyPackage' => '\\StructType\\PrintOnlyPackage',
            'mirror' => '\\StructType\\Mirror',
            'shadowBoxPackage' => '\\StructType\\ShadowBoxPackage',
            'externalOrderLineItem' => '\\StructType\\ExternalOrderLineItem',
            'channelItemId' => '\\StructType\\ChannelItemId',
            'channelSpecificIdentifier' => '\\StructType\\ChannelSpecificIdentifier',
            'costData' => '\\StructType\\CostData',
            'message' => '\\StructType\\Message',
            'assemblyFee' => '\\StructType\\AssemblyFee',
            'cash' => '\\StructType\\Cash',
            'externalOrder' => '\\StructType\\ExternalOrder',
            'channelOrderId' => '\\StructType\\ChannelOrderId',
            'externalCustomer' => '\\StructType\\ExternalCustomer',
            'externalAddress' => '\\StructType\\ExternalAddress',
            'shippingData' => '\\StructType\\ShippingData',
            'internationalShipping' => '\\StructType\\InternationalShipping',
            'otherUsShipping' => '\\StructType\\OtherUsShipping',
            'shippingCostData' => '\\StructType\\ShippingCostData',
            'canvas' => '\\StructType\\Canvas',
            'creditCard' => '\\StructType\\CreditCard',
            'documentPrintJob' => '\\StructType\\DocumentPrintJob',
            'printAndFramePackage' => '\\StructType\\PrintAndFramePackage',
            'stretcherBar' => '\\StructType\\StretcherBar',
            'canvasWrapPackage' => '\\StructType\\CanvasWrapPackage',
            'mirrorPackage' => '\\StructType\\MirrorPackage',
            'payPal' => '\\StructType\\PayPal',
            'merchantAccount' => '\\StructType\\MerchantAccount',
            'externalPrePackage' => '\\StructType\\ExternalPrePackage',
            'collection' => '\\StructType\\Collection',
            'condorFramePackage' => '\\StructType\\CondorFramePackage',
            'paper' => '\\StructType\\Paper',
            'ragMat' => '\\StructType\\RagMat',
            'check' => '\\StructType\\Check',
            'externalOrderStatus' => '\\StructType\\ExternalOrderStatus',
            'ServiceException' => '\\StructType\\ServiceException',
            'getOrderStatus' => '\\StructType\\GetOrderStatus',
            'getOrderStatusResponse' => '\\StructType\\GetOrderStatusResponse',
            'introduceExternalObjects' => '\\StructType\\IntroduceExternalObjects',
            'introduceExternalObjectsResponse' => '\\StructType\\IntroduceExternalObjectsResponse',
            'processOrder' => '\\StructType\\ProcessOrder',
            'processOrderResponse' => '\\StructType\\ProcessOrderResponse',
            'prepareOrder' => '\\StructType\\PrepareOrder',
            'prepareOrderResponse' => '\\StructType\\PrepareOrderResponse',
            'addProductToPackage' => '\\StructType\\AddProductToPackage',
            'addProductToPackageResponse' => '\\StructType\\AddProductToPackageResponse',
            'setOrderStatus' => '\\StructType\\SetOrderStatus',
            'setOrderStatusResponse' => '\\StructType\\SetOrderStatusResponse',
            'validatePaymentMethods' => '\\StructType\\ValidatePaymentMethods',
            'validatePaymentMethodsResponse' => '\\StructType\\ValidatePaymentMethodsResponse',
            'createPackage' => '\\StructType\\CreatePackage',
            'createPackageResponse' => '\\StructType\\CreatePackageResponse',
            'removeProductFromPackage' => '\\StructType\\RemoveProductFromPackage',
            'removeProductFromPackageResponse' => '\\StructType\\RemoveProductFromPackageResponse',
            'createPrePackage' => '\\StructType\\CreatePrePackage',
            'createPrePackageResponse' => '\\StructType\\CreatePrePackageResponse',
            'processCoupon' => '\\StructType\\ProcessCoupon',
            'processCouponResponse' => '\\StructType\\ProcessCouponResponse',
            'processFramerOrder' => '\\StructType\\ProcessFramerOrder',
            'processFramerOrderResponse' => '\\StructType\\ProcessFramerOrderResponse',
            'getOrderByCustomerName' => '\\StructType\\GetOrderByCustomerName',
            'getOrderByCustomerNameResponse' => '\\StructType\\GetOrderByCustomerNameResponse',
            'getOrderStatusHistory' => '\\StructType\\GetOrderStatusHistory',
            'getOrderStatusHistoryResponse' => '\\StructType\\GetOrderStatusHistoryResponse',
        );
    }
}
