<?php

namespace EnumType;

/**
 * This class stands for affixMethod EnumType
 * @subpackage Enumerations
 */
class AffixMethod
{
    /**
     * Constant for value 'ADHERE'
     * @return string 'ADHERE'
     */
    const VALUE_ADHERE = 'ADHERE';
    /**
     * Constant for value 'INSERT'
     * @return string 'INSERT'
     */
    const VALUE_INSERT = 'INSERT';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_ADHERE
     * @uses self::VALUE_INSERT
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_ADHERE,
            self::VALUE_INSERT,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
