<?php

namespace EnumType;

/**
 * This class stands for cardType EnumType
 * @subpackage Enumerations
 */
class CardType
{
    /**
     * Constant for value 'DS'
     * @return string 'DS'
     */
    const VALUE_DS = 'DS';
    /**
     * Constant for value 'AX'
     * @return string 'AX'
     */
    const VALUE_AX = 'AX';
    /**
     * Constant for value 'MC'
     * @return string 'MC'
     */
    const VALUE_MC = 'MC';
    /**
     * Constant for value 'VS'
     * @return string 'VS'
     */
    const VALUE_VS = 'VS';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_DS
     * @uses self::VALUE_AX
     * @uses self::VALUE_MC
     * @uses self::VALUE_VS
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_DS,
            self::VALUE_AX,
            self::VALUE_MC,
            self::VALUE_VS,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
