<?php

namespace EnumType;

/**
 * This class stands for documentType EnumType
 * @subpackage Enumerations
 */
class DocumentType
{
    /**
     * Constant for value 'PACKING_SLIP'
     * @return string 'PACKING_SLIP'
     */
    const VALUE_PACKING_SLIP = 'PACKING_SLIP';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_PACKING_SLIP
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_PACKING_SLIP,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
