<?php

namespace EnumType;

/**
 * This class stands for shippingServices EnumType
 * @subpackage Enumerations
 */
class ShippingServices
{
    /**
     * Constant for value 'USPS'
     * @return string 'USPS'
     */
    const VALUE_USPS = 'USPS';
    /**
     * Constant for value 'SATURDAY'
     * @return string 'SATURDAY'
     */
    const VALUE_SATURDAY = 'SATURDAY';
    /**
     * Constant for value 'NEXT_BUSINESS_PRIORITY'
     * @return string 'NEXT_BUSINESS_PRIORITY'
     */
    const VALUE_NEXT_BUSINESS_PRIORITY = 'NEXT_BUSINESS_PRIORITY';
    /**
     * Constant for value 'NEXT_DAY'
     * @return string 'NEXT_DAY'
     */
    const VALUE_NEXT_DAY = 'NEXT_DAY';
    /**
     * Constant for value 'SECOND_DAY'
     * @return string 'SECOND_DAY'
     */
    const VALUE_SECOND_DAY = 'SECOND_DAY';
    /**
     * Constant for value 'STANDARD'
     * @return string 'STANDARD'
     */
    const VALUE_STANDARD = 'STANDARD';
    /**
     * Constant for value 'PARCEL_POST'
     * @return string 'PARCEL_POST'
     */
    const VALUE_PARCEL_POST = 'PARCEL_POST';
    /**
     * Constant for value 'USPS_GLOBAL'
     * @return string 'USPS_GLOBAL'
     */
    const VALUE_USPS_GLOBAL = 'USPS_GLOBAL';
    /**
     * Constant for value 'USPS_PARCEL'
     * @return string 'USPS_PARCEL'
     */
    const VALUE_USPS_PARCEL = 'USPS_PARCEL';
    /**
     * Constant for value 'FEDEX_INT_ECON'
     * @return string 'FEDEX_INT_ECON'
     */
    const VALUE_FEDEX_INT_ECON = 'FEDEX_INT_ECON';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_USPS
     * @uses self::VALUE_SATURDAY
     * @uses self::VALUE_NEXT_BUSINESS_PRIORITY
     * @uses self::VALUE_NEXT_DAY
     * @uses self::VALUE_SECOND_DAY
     * @uses self::VALUE_STANDARD
     * @uses self::VALUE_PARCEL_POST
     * @uses self::VALUE_USPS_GLOBAL
     * @uses self::VALUE_USPS_PARCEL
     * @uses self::VALUE_FEDEX_INT_ECON
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_USPS,
            self::VALUE_SATURDAY,
            self::VALUE_NEXT_BUSINESS_PRIORITY,
            self::VALUE_NEXT_DAY,
            self::VALUE_SECOND_DAY,
            self::VALUE_STANDARD,
            self::VALUE_PARCEL_POST,
            self::VALUE_USPS_GLOBAL,
            self::VALUE_USPS_PARCEL,
            self::VALUE_FEDEX_INT_ECON,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
