<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Introduce ServiceType
 * @subpackage Services
 */
class Introduce extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named introduceExternalObjects
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\IntroduceExternalObjects $parameters
     * @return \StructType\IntroduceExternalObjectsResponse|bool
     */
    public function introduceExternalObjects(\StructType\IntroduceExternalObjects $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->introduceExternalObjects($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\IntroduceExternalObjectsResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
