<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for board StructType
 * @subpackage Structs
 */
class Board extends DimensionedExternalProduct
{
    /**
     * The material
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $material;
    /**
     * Constructor method for board
     * @uses Board::setMaterial()
     * @param string $material
     */
    public function __construct($material = null)
    {
        $this
            ->setMaterial($material);
    }
    /**
     * Get material value
     * @return string|null
     */
    public function getMaterial()
    {
        return $this->material;
    }
    /**
     * Set material value
     * @param string $material
     * @return \StructType\Board
     */
    public function setMaterial($material = null)
    {
        // validation for constraint: string
        if (!is_null($material) && !is_string($material)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($material)), __LINE__);
        }
        $this->material = $material;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Board
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
