<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for channel StructType
 * @subpackage Structs
 */
class Channel extends AbstractStructBase
{
    /**
     * The partner
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $partner;
    /**
     * The id
     * @var string
     */
    public $id;
    /**
     * Constructor method for channel
     * @uses Channel::setPartner()
     * @uses Channel::setId()
     * @param string $partner
     * @param string $id
     */
    public function __construct($partner = null, $id = null)
    {
        $this
            ->setPartner($partner)
            ->setId($id);
    }
    /**
     * Get partner value
     * @return string|null
     */
    public function getPartner()
    {
        return $this->partner;
    }
    /**
     * Set partner value
     * @param string $partner
     * @return \StructType\Channel
     */
    public function setPartner($partner = null)
    {
        // validation for constraint: string
        if (!is_null($partner) && !is_string($partner)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($partner)), __LINE__);
        }
        $this->partner = $partner;
        return $this;
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\Channel
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Channel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
