<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createPrePackage StructType
 * Meta informations extracted from the WSDL
 * - type: tns:createPrePackage
 * @subpackage Structs
 */
class CreatePrePackage extends AbstractStructBase
{
    /**
     * The userAccessCde
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userAccessCde;
    /**
     * The package
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ExternalProductPackage
     */
    public $package;
    /**
     * Constructor method for createPrePackage
     * @uses CreatePrePackage::setUserAccessCde()
     * @uses CreatePrePackage::setPackage()
     * @param string $userAccessCde
     * @param \StructType\ExternalProductPackage $package
     */
    public function __construct($userAccessCde = null, \StructType\ExternalProductPackage $package = null)
    {
        $this
            ->setUserAccessCde($userAccessCde)
            ->setPackage($package);
    }
    /**
     * Get userAccessCde value
     * @return string|null
     */
    public function getUserAccessCde()
    {
        return $this->userAccessCde;
    }
    /**
     * Set userAccessCde value
     * @param string $userAccessCde
     * @return \StructType\CreatePrePackage
     */
    public function setUserAccessCde($userAccessCde = null)
    {
        // validation for constraint: string
        if (!is_null($userAccessCde) && !is_string($userAccessCde)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($userAccessCde)), __LINE__);
        }
        $this->userAccessCde = $userAccessCde;
        return $this;
    }
    /**
     * Get package value
     * @return \StructType\ExternalProductPackage|null
     */
    public function getPackage()
    {
        return $this->package;
    }
    /**
     * Set package value
     * @param \StructType\ExternalProductPackage $package
     * @return \StructType\CreatePrePackage
     */
    public function setPackage(\StructType\ExternalProductPackage $package = null)
    {
        $this->package = $package;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreatePrePackage
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
