<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for dimension StructType
 * @subpackage Structs
 */
class Dimension extends AbstractStructBase
{
    /**
     * The height
     * @var float
     */
    public $height;
    /**
     * The heightDecimal
     * @var float
     */
    public $heightDecimal;
    /**
     * The heightWhole
     * @var int
     */
    public $heightWhole;
    /**
     * The note
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $note;
    /**
     * The width
     * @var float
     */
    public $width;
    /**
     * The widthDecimal
     * @var float
     */
    public $widthDecimal;
    /**
     * The widthWhole
     * @var int
     */
    public $widthWhole;
    /**
     * Constructor method for dimension
     * @uses Dimension::setHeight()
     * @uses Dimension::setHeightDecimal()
     * @uses Dimension::setHeightWhole()
     * @uses Dimension::setNote()
     * @uses Dimension::setWidth()
     * @uses Dimension::setWidthDecimal()
     * @uses Dimension::setWidthWhole()
     * @param float $height
     * @param float $heightDecimal
     * @param int $heightWhole
     * @param string $note
     * @param float $width
     * @param float $widthDecimal
     * @param int $widthWhole
     */
    public function __construct($height = null, $heightDecimal = null, $heightWhole = null, $note = null, $width = null, $widthDecimal = null, $widthWhole = null)
    {
        $this
            ->setHeight($height)
            ->setHeightDecimal($heightDecimal)
            ->setHeightWhole($heightWhole)
            ->setNote($note)
            ->setWidth($width)
            ->setWidthDecimal($widthDecimal)
            ->setWidthWhole($widthWhole);
    }
    /**
     * Get height value
     * @return float|null
     */
    public function getHeight()
    {
        return $this->height;
    }
    /**
     * Set height value
     * @param float $height
     * @return \StructType\Dimension
     */
    public function setHeight($height = null)
    {
        $this->height = $height;
        return $this;
    }
    /**
     * Get heightDecimal value
     * @return float|null
     */
    public function getHeightDecimal()
    {
        return $this->heightDecimal;
    }
    /**
     * Set heightDecimal value
     * @param float $heightDecimal
     * @return \StructType\Dimension
     */
    public function setHeightDecimal($heightDecimal = null)
    {
        $this->heightDecimal = $heightDecimal;
        return $this;
    }
    /**
     * Get heightWhole value
     * @return int|null
     */
    public function getHeightWhole()
    {
        return $this->heightWhole;
    }
    /**
     * Set heightWhole value
     * @param int $heightWhole
     * @return \StructType\Dimension
     */
    public function setHeightWhole($heightWhole = null)
    {
        // validation for constraint: int
        if (!is_null($heightWhole) && !is_numeric($heightWhole)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($heightWhole)), __LINE__);
        }
        $this->heightWhole = $heightWhole;
        return $this;
    }
    /**
     * Get note value
     * @return string|null
     */
    public function getNote()
    {
        return $this->note;
    }
    /**
     * Set note value
     * @param string $note
     * @return \StructType\Dimension
     */
    public function setNote($note = null)
    {
        // validation for constraint: string
        if (!is_null($note) && !is_string($note)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($note)), __LINE__);
        }
        $this->note = $note;
        return $this;
    }
    /**
     * Get width value
     * @return float|null
     */
    public function getWidth()
    {
        return $this->width;
    }
    /**
     * Set width value
     * @param float $width
     * @return \StructType\Dimension
     */
    public function setWidth($width = null)
    {
        $this->width = $width;
        return $this;
    }
    /**
     * Get widthDecimal value
     * @return float|null
     */
    public function getWidthDecimal()
    {
        return $this->widthDecimal;
    }
    /**
     * Set widthDecimal value
     * @param float $widthDecimal
     * @return \StructType\Dimension
     */
    public function setWidthDecimal($widthDecimal = null)
    {
        $this->widthDecimal = $widthDecimal;
        return $this;
    }
    /**
     * Get widthWhole value
     * @return int|null
     */
    public function getWidthWhole()
    {
        return $this->widthWhole;
    }
    /**
     * Set widthWhole value
     * @param int $widthWhole
     * @return \StructType\Dimension
     */
    public function setWidthWhole($widthWhole = null)
    {
        // validation for constraint: int
        if (!is_null($widthWhole) && !is_numeric($widthWhole)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($widthWhole)), __LINE__);
        }
        $this->widthWhole = $widthWhole;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Dimension
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
