<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for externalCriteria StructType
 * @subpackage Structs
 */
class ExternalCriteria extends AbstractStructBase
{
    /**
     * The criteriaType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $criteriaType;
    /**
     * The criteriaValue
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $criteriaValue;
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $id;
    /**
     * The operatorInd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $operatorInd;
    /**
     * Constructor method for externalCriteria
     * @uses ExternalCriteria::setCriteriaType()
     * @uses ExternalCriteria::setCriteriaValue()
     * @uses ExternalCriteria::setId()
     * @uses ExternalCriteria::setOperatorInd()
     * @param string $criteriaType
     * @param string $criteriaValue
     * @param int $id
     * @param int $operatorInd
     */
    public function __construct($criteriaType = null, $criteriaValue = null, $id = null, $operatorInd = null)
    {
        $this
            ->setCriteriaType($criteriaType)
            ->setCriteriaValue($criteriaValue)
            ->setId($id)
            ->setOperatorInd($operatorInd);
    }
    /**
     * Get criteriaType value
     * @return string|null
     */
    public function getCriteriaType()
    {
        return $this->criteriaType;
    }
    /**
     * Set criteriaType value
     * @param string $criteriaType
     * @return \StructType\ExternalCriteria
     */
    public function setCriteriaType($criteriaType = null)
    {
        // validation for constraint: string
        if (!is_null($criteriaType) && !is_string($criteriaType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($criteriaType)), __LINE__);
        }
        $this->criteriaType = $criteriaType;
        return $this;
    }
    /**
     * Get criteriaValue value
     * @return string|null
     */
    public function getCriteriaValue()
    {
        return $this->criteriaValue;
    }
    /**
     * Set criteriaValue value
     * @param string $criteriaValue
     * @return \StructType\ExternalCriteria
     */
    public function setCriteriaValue($criteriaValue = null)
    {
        // validation for constraint: string
        if (!is_null($criteriaValue) && !is_string($criteriaValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($criteriaValue)), __LINE__);
        }
        $this->criteriaValue = $criteriaValue;
        return $this;
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \StructType\ExternalCriteria
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get operatorInd value
     * @return int|null
     */
    public function getOperatorInd()
    {
        return $this->operatorInd;
    }
    /**
     * Set operatorInd value
     * @param int $operatorInd
     * @return \StructType\ExternalCriteria
     */
    public function setOperatorInd($operatorInd = null)
    {
        // validation for constraint: int
        if (!is_null($operatorInd) && !is_numeric($operatorInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($operatorInd)), __LINE__);
        }
        $this->operatorInd = $operatorInd;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExternalCriteria
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
