<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for externalOrderConfirmation StructType
 * @subpackage Structs
 */
class ExternalOrderConfirmation extends AbstractStructBase
{
    /**
     * The code
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $code;
    /**
     * The externalId
     * @var int
     */
    public $externalId;
    /**
     * The message
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $message;
    /**
     * The orderId
     * @var int
     */
    public $orderId;
    /**
     * The orderShipped
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $orderShipped;
    /**
     * The orderedDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $orderedDate;
    /**
     * The trackingNum
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $trackingNum;
    /**
     * The trackingUrl
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $trackingUrl;
    /**
     * Constructor method for externalOrderConfirmation
     * @uses ExternalOrderConfirmation::setCode()
     * @uses ExternalOrderConfirmation::setExternalId()
     * @uses ExternalOrderConfirmation::setMessage()
     * @uses ExternalOrderConfirmation::setOrderId()
     * @uses ExternalOrderConfirmation::setOrderShipped()
     * @uses ExternalOrderConfirmation::setOrderedDate()
     * @uses ExternalOrderConfirmation::setTrackingNum()
     * @uses ExternalOrderConfirmation::setTrackingUrl()
     * @param string $code
     * @param int $externalId
     * @param string $message
     * @param int $orderId
     * @param string $orderShipped
     * @param string $orderedDate
     * @param string $trackingNum
     * @param string $trackingUrl
     */
    public function __construct($code = null, $externalId = null, $message = null, $orderId = null, $orderShipped = null, $orderedDate = null, $trackingNum = null, $trackingUrl = null)
    {
        $this
            ->setCode($code)
            ->setExternalId($externalId)
            ->setMessage($message)
            ->setOrderId($orderId)
            ->setOrderShipped($orderShipped)
            ->setOrderedDate($orderedDate)
            ->setTrackingNum($trackingNum)
            ->setTrackingUrl($trackingUrl);
    }
    /**
     * Get code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param string $code
     * @return \StructType\ExternalOrderConfirmation
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get externalId value
     * @return int|null
     */
    public function getExternalId()
    {
        return $this->externalId;
    }
    /**
     * Set externalId value
     * @param int $externalId
     * @return \StructType\ExternalOrderConfirmation
     */
    public function setExternalId($externalId = null)
    {
        // validation for constraint: int
        if (!is_null($externalId) && !is_numeric($externalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($externalId)), __LINE__);
        }
        $this->externalId = $externalId;
        return $this;
    }
    /**
     * Get message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->message;
    }
    /**
     * Set message value
     * @param string $message
     * @return \StructType\ExternalOrderConfirmation
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($message)), __LINE__);
        }
        $this->message = $message;
        return $this;
    }
    /**
     * Get orderId value
     * @return int|null
     */
    public function getOrderId()
    {
        return $this->orderId;
    }
    /**
     * Set orderId value
     * @param int $orderId
     * @return \StructType\ExternalOrderConfirmation
     */
    public function setOrderId($orderId = null)
    {
        // validation for constraint: int
        if (!is_null($orderId) && !is_numeric($orderId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($orderId)), __LINE__);
        }
        $this->orderId = $orderId;
        return $this;
    }
    /**
     * Get orderShipped value
     * @return string|null
     */
    public function getOrderShipped()
    {
        return $this->orderShipped;
    }
    /**
     * Set orderShipped value
     * @param string $orderShipped
     * @return \StructType\ExternalOrderConfirmation
     */
    public function setOrderShipped($orderShipped = null)
    {
        // validation for constraint: string
        if (!is_null($orderShipped) && !is_string($orderShipped)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orderShipped)), __LINE__);
        }
        $this->orderShipped = $orderShipped;
        return $this;
    }
    /**
     * Get orderedDate value
     * @return string|null
     */
    public function getOrderedDate()
    {
        return $this->orderedDate;
    }
    /**
     * Set orderedDate value
     * @param string $orderedDate
     * @return \StructType\ExternalOrderConfirmation
     */
    public function setOrderedDate($orderedDate = null)
    {
        // validation for constraint: string
        if (!is_null($orderedDate) && !is_string($orderedDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orderedDate)), __LINE__);
        }
        $this->orderedDate = $orderedDate;
        return $this;
    }
    /**
     * Get trackingNum value
     * @return string|null
     */
    public function getTrackingNum()
    {
        return $this->trackingNum;
    }
    /**
     * Set trackingNum value
     * @param string $trackingNum
     * @return \StructType\ExternalOrderConfirmation
     */
    public function setTrackingNum($trackingNum = null)
    {
        // validation for constraint: string
        if (!is_null($trackingNum) && !is_string($trackingNum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($trackingNum)), __LINE__);
        }
        $this->trackingNum = $trackingNum;
        return $this;
    }
    /**
     * Get trackingUrl value
     * @return string|null
     */
    public function getTrackingUrl()
    {
        return $this->trackingUrl;
    }
    /**
     * Set trackingUrl value
     * @param string $trackingUrl
     * @return \StructType\ExternalOrderConfirmation
     */
    public function setTrackingUrl($trackingUrl = null)
    {
        // validation for constraint: string
        if (!is_null($trackingUrl) && !is_string($trackingUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($trackingUrl)), __LINE__);
        }
        $this->trackingUrl = $trackingUrl;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExternalOrderConfirmation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
