<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for externalOrderStatus StructType
 * @subpackage Structs
 */
class ExternalOrderStatus extends AbstractStructBase
{
    /**
     * The date
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $date;
    /**
     * The externalId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $externalId;
    /**
     * The orderId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $orderId;
    /**
     * The status
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The trackingLink
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $trackingLink;
    /**
     * The vendorId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $vendorId;
    /**
     * Constructor method for externalOrderStatus
     * @uses ExternalOrderStatus::setDate()
     * @uses ExternalOrderStatus::setExternalId()
     * @uses ExternalOrderStatus::setOrderId()
     * @uses ExternalOrderStatus::setStatus()
     * @uses ExternalOrderStatus::setTrackingLink()
     * @uses ExternalOrderStatus::setVendorId()
     * @param string $date
     * @param int $externalId
     * @param int $orderId
     * @param string $status
     * @param string $trackingLink
     * @param int $vendorId
     */
    public function __construct($date = null, $externalId = null, $orderId = null, $status = null, $trackingLink = null, $vendorId = null)
    {
        $this
            ->setDate($date)
            ->setExternalId($externalId)
            ->setOrderId($orderId)
            ->setStatus($status)
            ->setTrackingLink($trackingLink)
            ->setVendorId($vendorId);
    }
    /**
     * Get date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->date;
    }
    /**
     * Set date value
     * @param string $date
     * @return \StructType\ExternalOrderStatus
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($date)), __LINE__);
        }
        $this->date = $date;
        return $this;
    }
    /**
     * Get externalId value
     * @return int|null
     */
    public function getExternalId()
    {
        return $this->externalId;
    }
    /**
     * Set externalId value
     * @param int $externalId
     * @return \StructType\ExternalOrderStatus
     */
    public function setExternalId($externalId = null)
    {
        // validation for constraint: int
        if (!is_null($externalId) && !is_numeric($externalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($externalId)), __LINE__);
        }
        $this->externalId = $externalId;
        return $this;
    }
    /**
     * Get orderId value
     * @return int|null
     */
    public function getOrderId()
    {
        return $this->orderId;
    }
    /**
     * Set orderId value
     * @param int $orderId
     * @return \StructType\ExternalOrderStatus
     */
    public function setOrderId($orderId = null)
    {
        // validation for constraint: int
        if (!is_null($orderId) && !is_numeric($orderId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($orderId)), __LINE__);
        }
        $this->orderId = $orderId;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\ExternalOrderStatus
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get trackingLink value
     * @return string|null
     */
    public function getTrackingLink()
    {
        return $this->trackingLink;
    }
    /**
     * Set trackingLink value
     * @param string $trackingLink
     * @return \StructType\ExternalOrderStatus
     */
    public function setTrackingLink($trackingLink = null)
    {
        // validation for constraint: string
        if (!is_null($trackingLink) && !is_string($trackingLink)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($trackingLink)), __LINE__);
        }
        $this->trackingLink = $trackingLink;
        return $this;
    }
    /**
     * Get vendorId value
     * @return int|null
     */
    public function getVendorId()
    {
        return $this->vendorId;
    }
    /**
     * Set vendorId value
     * @param int $vendorId
     * @return \StructType\ExternalOrderStatus
     */
    public function setVendorId($vendorId = null)
    {
        // validation for constraint: int
        if (!is_null($vendorId) && !is_numeric($vendorId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($vendorId)), __LINE__);
        }
        $this->vendorId = $vendorId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExternalOrderStatus
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
