<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for externalUser StructType
 * @subpackage Structs
 */
class ExternalUser extends AbstractStructBase
{
    /**
     * The accessCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $accessCode;
    /**
     * The affCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $affCode;
    /**
     * The discountAmount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $discountAmount;
    /**
     * The hasCXAssembly
     * @var bool
     */
    public $hasCXAssembly;
    /**
     * The orderPrefixCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $orderPrefixCode;
    /**
     * The userId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $userId;
    /**
     * The userName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userName;
    /**
     * Constructor method for externalUser
     * @uses ExternalUser::setAccessCode()
     * @uses ExternalUser::setAffCode()
     * @uses ExternalUser::setDiscountAmount()
     * @uses ExternalUser::setHasCXAssembly()
     * @uses ExternalUser::setOrderPrefixCode()
     * @uses ExternalUser::setUserId()
     * @uses ExternalUser::setUserName()
     * @param string $accessCode
     * @param string $affCode
     * @param float $discountAmount
     * @param bool $hasCXAssembly
     * @param string $orderPrefixCode
     * @param int $userId
     * @param string $userName
     */
    public function __construct($accessCode = null, $affCode = null, $discountAmount = null, $hasCXAssembly = null, $orderPrefixCode = null, $userId = null, $userName = null)
    {
        $this
            ->setAccessCode($accessCode)
            ->setAffCode($affCode)
            ->setDiscountAmount($discountAmount)
            ->setHasCXAssembly($hasCXAssembly)
            ->setOrderPrefixCode($orderPrefixCode)
            ->setUserId($userId)
            ->setUserName($userName);
    }
    /**
     * Get accessCode value
     * @return string|null
     */
    public function getAccessCode()
    {
        return $this->accessCode;
    }
    /**
     * Set accessCode value
     * @param string $accessCode
     * @return \StructType\ExternalUser
     */
    public function setAccessCode($accessCode = null)
    {
        // validation for constraint: string
        if (!is_null($accessCode) && !is_string($accessCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accessCode)), __LINE__);
        }
        $this->accessCode = $accessCode;
        return $this;
    }
    /**
     * Get affCode value
     * @return string|null
     */
    public function getAffCode()
    {
        return $this->affCode;
    }
    /**
     * Set affCode value
     * @param string $affCode
     * @return \StructType\ExternalUser
     */
    public function setAffCode($affCode = null)
    {
        // validation for constraint: string
        if (!is_null($affCode) && !is_string($affCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($affCode)), __LINE__);
        }
        $this->affCode = $affCode;
        return $this;
    }
    /**
     * Get discountAmount value
     * @return float|null
     */
    public function getDiscountAmount()
    {
        return $this->discountAmount;
    }
    /**
     * Set discountAmount value
     * @param float $discountAmount
     * @return \StructType\ExternalUser
     */
    public function setDiscountAmount($discountAmount = null)
    {
        $this->discountAmount = $discountAmount;
        return $this;
    }
    /**
     * Get hasCXAssembly value
     * @return bool|null
     */
    public function getHasCXAssembly()
    {
        return $this->hasCXAssembly;
    }
    /**
     * Set hasCXAssembly value
     * @param bool $hasCXAssembly
     * @return \StructType\ExternalUser
     */
    public function setHasCXAssembly($hasCXAssembly = null)
    {
        $this->hasCXAssembly = $hasCXAssembly;
        return $this;
    }
    /**
     * Get orderPrefixCode value
     * @return string|null
     */
    public function getOrderPrefixCode()
    {
        return $this->orderPrefixCode;
    }
    /**
     * Set orderPrefixCode value
     * @param string $orderPrefixCode
     * @return \StructType\ExternalUser
     */
    public function setOrderPrefixCode($orderPrefixCode = null)
    {
        // validation for constraint: string
        if (!is_null($orderPrefixCode) && !is_string($orderPrefixCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orderPrefixCode)), __LINE__);
        }
        $this->orderPrefixCode = $orderPrefixCode;
        return $this;
    }
    /**
     * Get userId value
     * @return int|null
     */
    public function getUserId()
    {
        return $this->userId;
    }
    /**
     * Set userId value
     * @param int $userId
     * @return \StructType\ExternalUser
     */
    public function setUserId($userId = null)
    {
        // validation for constraint: int
        if (!is_null($userId) && !is_numeric($userId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($userId)), __LINE__);
        }
        $this->userId = $userId;
        return $this;
    }
    /**
     * Get userName value
     * @return string|null
     */
    public function getUserName()
    {
        return $this->userName;
    }
    /**
     * Set userName value
     * @param string $userName
     * @return \StructType\ExternalUser
     */
    public function setUserName($userName = null)
    {
        // validation for constraint: string
        if (!is_null($userName) && !is_string($userName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($userName)), __LINE__);
        }
        $this->userName = $userName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExternalUser
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
