<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for floatMount StructType
 * @subpackage Structs
 */
class FloatMount extends ExternalProductPackage
{
    /**
     * The bottomImageBorderOffest
     * @var float
     */
    public $bottomImageBorderOffest;
    /**
     * The leftImageBorderOffest
     * @var float
     */
    public $leftImageBorderOffest;
    /**
     * The rightImageBorderOffest
     * @var float
     */
    public $rightImageBorderOffest;
    /**
     * The topImageBorderOffest
     * @var float
     */
    public $topImageBorderOffest;
    /**
     * Constructor method for floatMount
     * @uses FloatMount::setBottomImageBorderOffest()
     * @uses FloatMount::setLeftImageBorderOffest()
     * @uses FloatMount::setRightImageBorderOffest()
     * @uses FloatMount::setTopImageBorderOffest()
     * @param float $bottomImageBorderOffest
     * @param float $leftImageBorderOffest
     * @param float $rightImageBorderOffest
     * @param float $topImageBorderOffest
     */
    public function __construct($bottomImageBorderOffest = null, $leftImageBorderOffest = null, $rightImageBorderOffest = null, $topImageBorderOffest = null)
    {
        $this
            ->setBottomImageBorderOffest($bottomImageBorderOffest)
            ->setLeftImageBorderOffest($leftImageBorderOffest)
            ->setRightImageBorderOffest($rightImageBorderOffest)
            ->setTopImageBorderOffest($topImageBorderOffest);
    }
    /**
     * Get bottomImageBorderOffest value
     * @return float|null
     */
    public function getBottomImageBorderOffest()
    {
        return $this->bottomImageBorderOffest;
    }
    /**
     * Set bottomImageBorderOffest value
     * @param float $bottomImageBorderOffest
     * @return \StructType\FloatMount
     */
    public function setBottomImageBorderOffest($bottomImageBorderOffest = null)
    {
        $this->bottomImageBorderOffest = $bottomImageBorderOffest;
        return $this;
    }
    /**
     * Get leftImageBorderOffest value
     * @return float|null
     */
    public function getLeftImageBorderOffest()
    {
        return $this->leftImageBorderOffest;
    }
    /**
     * Set leftImageBorderOffest value
     * @param float $leftImageBorderOffest
     * @return \StructType\FloatMount
     */
    public function setLeftImageBorderOffest($leftImageBorderOffest = null)
    {
        $this->leftImageBorderOffest = $leftImageBorderOffest;
        return $this;
    }
    /**
     * Get rightImageBorderOffest value
     * @return float|null
     */
    public function getRightImageBorderOffest()
    {
        return $this->rightImageBorderOffest;
    }
    /**
     * Set rightImageBorderOffest value
     * @param float $rightImageBorderOffest
     * @return \StructType\FloatMount
     */
    public function setRightImageBorderOffest($rightImageBorderOffest = null)
    {
        $this->rightImageBorderOffest = $rightImageBorderOffest;
        return $this;
    }
    /**
     * Get topImageBorderOffest value
     * @return float|null
     */
    public function getTopImageBorderOffest()
    {
        return $this->topImageBorderOffest;
    }
    /**
     * Set topImageBorderOffest value
     * @param float $topImageBorderOffest
     * @return \StructType\FloatMount
     */
    public function setTopImageBorderOffest($topImageBorderOffest = null)
    {
        $this->topImageBorderOffest = $topImageBorderOffest;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FloatMount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
