<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getOrderByCustomerNameResponse StructType
 * Meta informations extracted from the WSDL
 * - type: tns:getOrderByCustomerNameResponse
 * @subpackage Structs
 */
class GetOrderByCustomerNameResponse extends AbstractStructBase
{
    /**
     * The externalOrder
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ExternalOrder[]
     */
    public $externalOrder;
    /**
     * Constructor method for getOrderByCustomerNameResponse
     * @uses GetOrderByCustomerNameResponse::setExternalOrder()
     * @param \StructType\ExternalOrder[] $externalOrder
     */
    public function __construct(array $externalOrder = array())
    {
        $this
            ->setExternalOrder($externalOrder);
    }
    /**
     * Get externalOrder value
     * @return \StructType\ExternalOrder[]|null
     */
    public function getExternalOrder()
    {
        return $this->externalOrder;
    }
    /**
     * Set externalOrder value
     * @throws \InvalidArgumentException
     * @param \StructType\ExternalOrder[] $externalOrder
     * @return \StructType\GetOrderByCustomerNameResponse
     */
    public function setExternalOrder(array $externalOrder = array())
    {
        foreach ($externalOrder as $getOrderByCustomerNameResponseExternalOrderItem) {
            // validation for constraint: itemType
            if (!$getOrderByCustomerNameResponseExternalOrderItem instanceof \StructType\ExternalOrder) {
                throw new \InvalidArgumentException(sprintf('The externalOrder property can only contain items of \StructType\ExternalOrder, "%s" given', is_object($getOrderByCustomerNameResponseExternalOrderItem) ? get_class($getOrderByCustomerNameResponseExternalOrderItem) : gettype($getOrderByCustomerNameResponseExternalOrderItem)), __LINE__);
            }
        }
        $this->externalOrder = $externalOrder;
        return $this;
    }
    /**
     * Add item to externalOrder value
     * @throws \InvalidArgumentException
     * @param \StructType\ExternalOrder $item
     * @return \StructType\GetOrderByCustomerNameResponse
     */
    public function addToExternalOrder(\StructType\ExternalOrder $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ExternalOrder) {
            throw new \InvalidArgumentException(sprintf('The externalOrder property can only contain items of \StructType\ExternalOrder, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->externalOrder[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetOrderByCustomerNameResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
