<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getOrderStatusHistory StructType
 * Meta informations extracted from the WSDL
 * - type: tns:getOrderStatusHistory
 * @subpackage Structs
 */
class GetOrderStatusHistory extends AbstractStructBase
{
    /**
     * The userID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $userID;
    /**
     * The externalOrderID
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $externalOrderID;
    /**
     * Constructor method for getOrderStatusHistory
     * @uses GetOrderStatusHistory::setUserID()
     * @uses GetOrderStatusHistory::setExternalOrderID()
     * @param int $userID
     * @param int $externalOrderID
     */
    public function __construct($userID = null, $externalOrderID = null)
    {
        $this
            ->setUserID($userID)
            ->setExternalOrderID($externalOrderID);
    }
    /**
     * Get userID value
     * @return int|null
     */
    public function getUserID()
    {
        return $this->userID;
    }
    /**
     * Set userID value
     * @param int $userID
     * @return \StructType\GetOrderStatusHistory
     */
    public function setUserID($userID = null)
    {
        // validation for constraint: int
        if (!is_null($userID) && !is_numeric($userID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($userID)), __LINE__);
        }
        $this->userID = $userID;
        return $this;
    }
    /**
     * Get externalOrderID value
     * @return int|null
     */
    public function getExternalOrderID()
    {
        return $this->externalOrderID;
    }
    /**
     * Set externalOrderID value
     * @param int $externalOrderID
     * @return \StructType\GetOrderStatusHistory
     */
    public function setExternalOrderID($externalOrderID = null)
    {
        // validation for constraint: int
        if (!is_null($externalOrderID) && !is_numeric($externalOrderID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($externalOrderID)), __LINE__);
        }
        $this->externalOrderID = $externalOrderID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetOrderStatusHistory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
