<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getOrderStatusHistoryResponse StructType
 * Meta informations extracted from the WSDL
 * - type: tns:getOrderStatusHistoryResponse
 * @subpackage Structs
 */
class GetOrderStatusHistoryResponse extends AbstractStructBase
{
    /**
     * The orderStatusHistory
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ExternalOrderStatus[]
     */
    public $orderStatusHistory;
    /**
     * Constructor method for getOrderStatusHistoryResponse
     * @uses GetOrderStatusHistoryResponse::setOrderStatusHistory()
     * @param \StructType\ExternalOrderStatus[] $orderStatusHistory
     */
    public function __construct(array $orderStatusHistory = array())
    {
        $this
            ->setOrderStatusHistory($orderStatusHistory);
    }
    /**
     * Get orderStatusHistory value
     * @return \StructType\ExternalOrderStatus[]|null
     */
    public function getOrderStatusHistory()
    {
        return $this->orderStatusHistory;
    }
    /**
     * Set orderStatusHistory value
     * @throws \InvalidArgumentException
     * @param \StructType\ExternalOrderStatus[] $orderStatusHistory
     * @return \StructType\GetOrderStatusHistoryResponse
     */
    public function setOrderStatusHistory(array $orderStatusHistory = array())
    {
        foreach ($orderStatusHistory as $getOrderStatusHistoryResponseOrderStatusHistoryItem) {
            // validation for constraint: itemType
            if (!$getOrderStatusHistoryResponseOrderStatusHistoryItem instanceof \StructType\ExternalOrderStatus) {
                throw new \InvalidArgumentException(sprintf('The orderStatusHistory property can only contain items of \StructType\ExternalOrderStatus, "%s" given', is_object($getOrderStatusHistoryResponseOrderStatusHistoryItem) ? get_class($getOrderStatusHistoryResponseOrderStatusHistoryItem) : gettype($getOrderStatusHistoryResponseOrderStatusHistoryItem)), __LINE__);
            }
        }
        $this->orderStatusHistory = $orderStatusHistory;
        return $this;
    }
    /**
     * Add item to orderStatusHistory value
     * @throws \InvalidArgumentException
     * @param \StructType\ExternalOrderStatus $item
     * @return \StructType\GetOrderStatusHistoryResponse
     */
    public function addToOrderStatusHistory(\StructType\ExternalOrderStatus $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ExternalOrderStatus) {
            throw new \InvalidArgumentException(sprintf('The orderStatusHistory property can only contain items of \StructType\ExternalOrderStatus, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->orderStatusHistory[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetOrderStatusHistoryResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
