<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for giftData StructType
 * @subpackage Structs
 */
class GiftData extends AbstractStructBase
{
    /**
     * The greeting
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $greeting;
    /**
     * The message
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $message;
    /**
     * The signature
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $signature;
    /**
     * Constructor method for giftData
     * @uses GiftData::setGreeting()
     * @uses GiftData::setMessage()
     * @uses GiftData::setSignature()
     * @param string $greeting
     * @param string $message
     * @param string $signature
     */
    public function __construct($greeting = null, $message = null, $signature = null)
    {
        $this
            ->setGreeting($greeting)
            ->setMessage($message)
            ->setSignature($signature);
    }
    /**
     * Get greeting value
     * @return string|null
     */
    public function getGreeting()
    {
        return $this->greeting;
    }
    /**
     * Set greeting value
     * @param string $greeting
     * @return \StructType\GiftData
     */
    public function setGreeting($greeting = null)
    {
        // validation for constraint: string
        if (!is_null($greeting) && !is_string($greeting)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($greeting)), __LINE__);
        }
        $this->greeting = $greeting;
        return $this;
    }
    /**
     * Get message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->message;
    }
    /**
     * Set message value
     * @param string $message
     * @return \StructType\GiftData
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($message)), __LINE__);
        }
        $this->message = $message;
        return $this;
    }
    /**
     * Get signature value
     * @return string|null
     */
    public function getSignature()
    {
        return $this->signature;
    }
    /**
     * Set signature value
     * @param string $signature
     * @return \StructType\GiftData
     */
    public function setSignature($signature = null)
    {
        // validation for constraint: string
        if (!is_null($signature) && !is_string($signature)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($signature)), __LINE__);
        }
        $this->signature = $signature;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GiftData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
