<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for matBoard StructType
 * @subpackage Structs
 */
class MatBoard extends Mat
{
    /**
     * The imageOffsetBottom
     * @var float
     */
    public $imageOffsetBottom;
    /**
     * The imageOffsetLeft
     * @var float
     */
    public $imageOffsetLeft;
    /**
     * The imageOffsetRight
     * @var float
     */
    public $imageOffsetRight;
    /**
     * The imageOffsetTop
     * @var float
     */
    public $imageOffsetTop;
    /**
     * Constructor method for matBoard
     * @uses MatBoard::setImageOffsetBottom()
     * @uses MatBoard::setImageOffsetLeft()
     * @uses MatBoard::setImageOffsetRight()
     * @uses MatBoard::setImageOffsetTop()
     * @param float $imageOffsetBottom
     * @param float $imageOffsetLeft
     * @param float $imageOffsetRight
     * @param float $imageOffsetTop
     */
    public function __construct($imageOffsetBottom = null, $imageOffsetLeft = null, $imageOffsetRight = null, $imageOffsetTop = null)
    {
        $this
            ->setImageOffsetBottom($imageOffsetBottom)
            ->setImageOffsetLeft($imageOffsetLeft)
            ->setImageOffsetRight($imageOffsetRight)
            ->setImageOffsetTop($imageOffsetTop);
    }
    /**
     * Get imageOffsetBottom value
     * @return float|null
     */
    public function getImageOffsetBottom()
    {
        return $this->imageOffsetBottom;
    }
    /**
     * Set imageOffsetBottom value
     * @param float $imageOffsetBottom
     * @return \StructType\MatBoard
     */
    public function setImageOffsetBottom($imageOffsetBottom = null)
    {
        $this->imageOffsetBottom = $imageOffsetBottom;
        return $this;
    }
    /**
     * Get imageOffsetLeft value
     * @return float|null
     */
    public function getImageOffsetLeft()
    {
        return $this->imageOffsetLeft;
    }
    /**
     * Set imageOffsetLeft value
     * @param float $imageOffsetLeft
     * @return \StructType\MatBoard
     */
    public function setImageOffsetLeft($imageOffsetLeft = null)
    {
        $this->imageOffsetLeft = $imageOffsetLeft;
        return $this;
    }
    /**
     * Get imageOffsetRight value
     * @return float|null
     */
    public function getImageOffsetRight()
    {
        return $this->imageOffsetRight;
    }
    /**
     * Set imageOffsetRight value
     * @param float $imageOffsetRight
     * @return \StructType\MatBoard
     */
    public function setImageOffsetRight($imageOffsetRight = null)
    {
        $this->imageOffsetRight = $imageOffsetRight;
        return $this;
    }
    /**
     * Get imageOffsetTop value
     * @return float|null
     */
    public function getImageOffsetTop()
    {
        return $this->imageOffsetTop;
    }
    /**
     * Set imageOffsetTop value
     * @param float $imageOffsetTop
     * @return \StructType\MatBoard
     */
    public function setImageOffsetTop($imageOffsetTop = null)
    {
        $this->imageOffsetTop = $imageOffsetTop;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MatBoard
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
