<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for mirrorPackage StructType
 * @subpackage Structs
 */
class MirrorPackage extends FramePackage
{
    /**
     * The mirror
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Mirror
     */
    public $mirror;
    /**
     * Constructor method for mirrorPackage
     * @uses MirrorPackage::setMirror()
     * @param \StructType\Mirror $mirror
     */
    public function __construct(\StructType\Mirror $mirror = null)
    {
        $this
            ->setMirror($mirror);
    }
    /**
     * Get mirror value
     * @return \StructType\Mirror|null
     */
    public function getMirror()
    {
        return $this->mirror;
    }
    /**
     * Set mirror value
     * @param \StructType\Mirror $mirror
     * @return \StructType\MirrorPackage
     */
    public function setMirror(\StructType\Mirror $mirror = null)
    {
        $this->mirror = $mirror;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MirrorPackage
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
