<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for payPal StructType
 * @subpackage Structs
 */
class PayPal extends PaymentMethod
{
    /**
     * The payPalAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $payPalAddress;
    /**
     * Constructor method for payPal
     * @uses PayPal::setPayPalAddress()
     * @param string $payPalAddress
     */
    public function __construct($payPalAddress = null)
    {
        $this
            ->setPayPalAddress($payPalAddress);
    }
    /**
     * Get payPalAddress value
     * @return string|null
     */
    public function getPayPalAddress()
    {
        return $this->payPalAddress;
    }
    /**
     * Set payPalAddress value
     * @param string $payPalAddress
     * @return \StructType\PayPal
     */
    public function setPayPalAddress($payPalAddress = null)
    {
        // validation for constraint: string
        if (!is_null($payPalAddress) && !is_string($payPalAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($payPalAddress)), __LINE__);
        }
        $this->payPalAddress = $payPalAddress;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PayPal
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
