<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for raisedMat StructType
 * @subpackage Structs
 */
class RaisedMat extends ExternalProduct
{
    /**
     * The height
     * @var float
     */
    public $height;
    /**
     * The matLocation
     * @var int
     */
    public $matLocation;
    /**
     * The width
     * @var float
     */
    public $width;
    /**
     * Constructor method for raisedMat
     * @uses RaisedMat::setHeight()
     * @uses RaisedMat::setMatLocation()
     * @uses RaisedMat::setWidth()
     * @param float $height
     * @param int $matLocation
     * @param float $width
     */
    public function __construct($height = null, $matLocation = null, $width = null)
    {
        $this
            ->setHeight($height)
            ->setMatLocation($matLocation)
            ->setWidth($width);
    }
    /**
     * Get height value
     * @return float|null
     */
    public function getHeight()
    {
        return $this->height;
    }
    /**
     * Set height value
     * @param float $height
     * @return \StructType\RaisedMat
     */
    public function setHeight($height = null)
    {
        $this->height = $height;
        return $this;
    }
    /**
     * Get matLocation value
     * @return int|null
     */
    public function getMatLocation()
    {
        return $this->matLocation;
    }
    /**
     * Set matLocation value
     * @param int $matLocation
     * @return \StructType\RaisedMat
     */
    public function setMatLocation($matLocation = null)
    {
        // validation for constraint: int
        if (!is_null($matLocation) && !is_numeric($matLocation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($matLocation)), __LINE__);
        }
        $this->matLocation = $matLocation;
        return $this;
    }
    /**
     * Get width value
     * @return float|null
     */
    public function getWidth()
    {
        return $this->width;
    }
    /**
     * Set width value
     * @param float $width
     * @return \StructType\RaisedMat
     */
    public function setWidth($width = null)
    {
        $this->width = $width;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RaisedMat
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
