<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for shippingCostData StructType
 * @subpackage Structs
 */
class ShippingCostData extends AbstractStructBase
{
    /**
     * The discountAmount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $discountAmount;
    /**
     * The methodCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $methodCode;
    /**
     * The methodName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $methodName;
    /**
     * The price
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $price;
    /**
     * Constructor method for shippingCostData
     * @uses ShippingCostData::setDiscountAmount()
     * @uses ShippingCostData::setMethodCode()
     * @uses ShippingCostData::setMethodName()
     * @uses ShippingCostData::setPrice()
     * @param float $discountAmount
     * @param string $methodCode
     * @param string $methodName
     * @param float $price
     */
    public function __construct($discountAmount = null, $methodCode = null, $methodName = null, $price = null)
    {
        $this
            ->setDiscountAmount($discountAmount)
            ->setMethodCode($methodCode)
            ->setMethodName($methodName)
            ->setPrice($price);
    }
    /**
     * Get discountAmount value
     * @return float|null
     */
    public function getDiscountAmount()
    {
        return $this->discountAmount;
    }
    /**
     * Set discountAmount value
     * @param float $discountAmount
     * @return \StructType\ShippingCostData
     */
    public function setDiscountAmount($discountAmount = null)
    {
        $this->discountAmount = $discountAmount;
        return $this;
    }
    /**
     * Get methodCode value
     * @return string|null
     */
    public function getMethodCode()
    {
        return $this->methodCode;
    }
    /**
     * Set methodCode value
     * @param string $methodCode
     * @return \StructType\ShippingCostData
     */
    public function setMethodCode($methodCode = null)
    {
        // validation for constraint: string
        if (!is_null($methodCode) && !is_string($methodCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($methodCode)), __LINE__);
        }
        $this->methodCode = $methodCode;
        return $this;
    }
    /**
     * Get methodName value
     * @return string|null
     */
    public function getMethodName()
    {
        return $this->methodName;
    }
    /**
     * Set methodName value
     * @param string $methodName
     * @return \StructType\ShippingCostData
     */
    public function setMethodName($methodName = null)
    {
        // validation for constraint: string
        if (!is_null($methodName) && !is_string($methodName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($methodName)), __LINE__);
        }
        $this->methodName = $methodName;
        return $this;
    }
    /**
     * Get price value
     * @return float|null
     */
    public function getPrice()
    {
        return $this->price;
    }
    /**
     * Set price value
     * @param float $price
     * @return \StructType\ShippingCostData
     */
    public function setPrice($price = null)
    {
        $this->price = $price;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ShippingCostData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
