<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for shippingData StructType
 * @subpackage Structs
 */
class ShippingData extends AbstractStructBase
{
    /**
     * The applicableExternalPromos
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ExternalPromo[]
     */
    public $applicableExternalPromos;
    /**
     * The baseCost
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $baseCost;
    /**
     * The carrier
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $carrier;
    /**
     * The carrierAccountId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $carrierAccountId;
    /**
     * The discountAmount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $discountAmount;
    /**
     * The internationalShippings
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InternationalShipping[]
     */
    public $internationalShippings;
    /**
     * The oneDayCost
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $oneDayCost;
    /**
     * The otherUsShippings
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OtherUsShipping[]
     */
    public $otherUsShippings;
    /**
     * The overNight
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $overNight;
    /**
     * The secondDayCost
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $secondDayCost;
    /**
     * The shippingCostDatas
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ShippingCostData[]
     */
    public $shippingCostDatas;
    /**
     * The shippingService
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $shippingService;
    /**
     * Constructor method for shippingData
     * @uses ShippingData::setApplicableExternalPromos()
     * @uses ShippingData::setBaseCost()
     * @uses ShippingData::setCarrier()
     * @uses ShippingData::setCarrierAccountId()
     * @uses ShippingData::setDiscountAmount()
     * @uses ShippingData::setInternationalShippings()
     * @uses ShippingData::setOneDayCost()
     * @uses ShippingData::setOtherUsShippings()
     * @uses ShippingData::setOverNight()
     * @uses ShippingData::setSecondDayCost()
     * @uses ShippingData::setShippingCostDatas()
     * @uses ShippingData::setShippingService()
     * @param \StructType\ExternalPromo[] $applicableExternalPromos
     * @param float $baseCost
     * @param string $carrier
     * @param string $carrierAccountId
     * @param float $discountAmount
     * @param \StructType\InternationalShipping[] $internationalShippings
     * @param float $oneDayCost
     * @param \StructType\OtherUsShipping[] $otherUsShippings
     * @param float $overNight
     * @param float $secondDayCost
     * @param \StructType\ShippingCostData[] $shippingCostDatas
     * @param string $shippingService
     */
    public function __construct(array $applicableExternalPromos = array(), $baseCost = null, $carrier = null, $carrierAccountId = null, $discountAmount = null, array $internationalShippings = array(), $oneDayCost = null, array $otherUsShippings = array(), $overNight = null, $secondDayCost = null, array $shippingCostDatas = array(), $shippingService = null)
    {
        $this
            ->setApplicableExternalPromos($applicableExternalPromos)
            ->setBaseCost($baseCost)
            ->setCarrier($carrier)
            ->setCarrierAccountId($carrierAccountId)
            ->setDiscountAmount($discountAmount)
            ->setInternationalShippings($internationalShippings)
            ->setOneDayCost($oneDayCost)
            ->setOtherUsShippings($otherUsShippings)
            ->setOverNight($overNight)
            ->setSecondDayCost($secondDayCost)
            ->setShippingCostDatas($shippingCostDatas)
            ->setShippingService($shippingService);
    }
    /**
     * Get applicableExternalPromos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ExternalPromo[]|null
     */
    public function getApplicableExternalPromos()
    {
        return isset($this->applicableExternalPromos) ? $this->applicableExternalPromos : null;
    }
    /**
     * Set applicableExternalPromos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ExternalPromo[] $applicableExternalPromos
     * @return \StructType\ShippingData
     */
    public function setApplicableExternalPromos(array $applicableExternalPromos = array())
    {
        foreach ($applicableExternalPromos as $shippingDataApplicableExternalPromosItem) {
            // validation for constraint: itemType
            if (!$shippingDataApplicableExternalPromosItem instanceof \StructType\ExternalPromo) {
                throw new \InvalidArgumentException(sprintf('The applicableExternalPromos property can only contain items of \StructType\ExternalPromo, "%s" given', is_object($shippingDataApplicableExternalPromosItem) ? get_class($shippingDataApplicableExternalPromosItem) : gettype($shippingDataApplicableExternalPromosItem)), __LINE__);
            }
        }
        if (is_null($applicableExternalPromos) || (is_array($applicableExternalPromos) && empty($applicableExternalPromos))) {
            unset($this->applicableExternalPromos);
        } else {
            $this->applicableExternalPromos = $applicableExternalPromos;
        }
        return $this;
    }
    /**
     * Add item to applicableExternalPromos value
     * @throws \InvalidArgumentException
     * @param \StructType\ExternalPromo $item
     * @return \StructType\ShippingData
     */
    public function addToApplicableExternalPromos(\StructType\ExternalPromo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ExternalPromo) {
            throw new \InvalidArgumentException(sprintf('The applicableExternalPromos property can only contain items of \StructType\ExternalPromo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->applicableExternalPromos[] = $item;
        return $this;
    }
    /**
     * Get baseCost value
     * @return float|null
     */
    public function getBaseCost()
    {
        return $this->baseCost;
    }
    /**
     * Set baseCost value
     * @param float $baseCost
     * @return \StructType\ShippingData
     */
    public function setBaseCost($baseCost = null)
    {
        $this->baseCost = $baseCost;
        return $this;
    }
    /**
     * Get carrier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCarrier()
    {
        return isset($this->carrier) ? $this->carrier : null;
    }
    /**
     * Set carrier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \EnumType\ShippingCarriers::valueIsValid()
     * @uses \EnumType\ShippingCarriers::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $carrier
     * @return \StructType\ShippingData
     */
    public function setCarrier($carrier = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ShippingCarriers::valueIsValid($carrier)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $carrier, implode(', ', \EnumType\ShippingCarriers::getValidValues())), __LINE__);
        }
        if (is_null($carrier) || (is_array($carrier) && empty($carrier))) {
            unset($this->carrier);
        } else {
            $this->carrier = $carrier;
        }
        return $this;
    }
    /**
     * Get carrierAccountId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCarrierAccountId()
    {
        return isset($this->carrierAccountId) ? $this->carrierAccountId : null;
    }
    /**
     * Set carrierAccountId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $carrierAccountId
     * @return \StructType\ShippingData
     */
    public function setCarrierAccountId($carrierAccountId = null)
    {
        // validation for constraint: string
        if (!is_null($carrierAccountId) && !is_string($carrierAccountId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($carrierAccountId)), __LINE__);
        }
        if (is_null($carrierAccountId) || (is_array($carrierAccountId) && empty($carrierAccountId))) {
            unset($this->carrierAccountId);
        } else {
            $this->carrierAccountId = $carrierAccountId;
        }
        return $this;
    }
    /**
     * Get discountAmount value
     * @return float|null
     */
    public function getDiscountAmount()
    {
        return $this->discountAmount;
    }
    /**
     * Set discountAmount value
     * @param float $discountAmount
     * @return \StructType\ShippingData
     */
    public function setDiscountAmount($discountAmount = null)
    {
        $this->discountAmount = $discountAmount;
        return $this;
    }
    /**
     * Get internationalShippings value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InternationalShipping[]|null
     */
    public function getInternationalShippings()
    {
        return isset($this->internationalShippings) ? $this->internationalShippings : null;
    }
    /**
     * Set internationalShippings value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InternationalShipping[] $internationalShippings
     * @return \StructType\ShippingData
     */
    public function setInternationalShippings(array $internationalShippings = array())
    {
        foreach ($internationalShippings as $shippingDataInternationalShippingsItem) {
            // validation for constraint: itemType
            if (!$shippingDataInternationalShippingsItem instanceof \StructType\InternationalShipping) {
                throw new \InvalidArgumentException(sprintf('The internationalShippings property can only contain items of \StructType\InternationalShipping, "%s" given', is_object($shippingDataInternationalShippingsItem) ? get_class($shippingDataInternationalShippingsItem) : gettype($shippingDataInternationalShippingsItem)), __LINE__);
            }
        }
        if (is_null($internationalShippings) || (is_array($internationalShippings) && empty($internationalShippings))) {
            unset($this->internationalShippings);
        } else {
            $this->internationalShippings = $internationalShippings;
        }
        return $this;
    }
    /**
     * Add item to internationalShippings value
     * @throws \InvalidArgumentException
     * @param \StructType\InternationalShipping $item
     * @return \StructType\ShippingData
     */
    public function addToInternationalShippings(\StructType\InternationalShipping $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InternationalShipping) {
            throw new \InvalidArgumentException(sprintf('The internationalShippings property can only contain items of \StructType\InternationalShipping, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->internationalShippings[] = $item;
        return $this;
    }
    /**
     * Get oneDayCost value
     * @return float|null
     */
    public function getOneDayCost()
    {
        return $this->oneDayCost;
    }
    /**
     * Set oneDayCost value
     * @param float $oneDayCost
     * @return \StructType\ShippingData
     */
    public function setOneDayCost($oneDayCost = null)
    {
        $this->oneDayCost = $oneDayCost;
        return $this;
    }
    /**
     * Get otherUsShippings value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OtherUsShipping[]|null
     */
    public function getOtherUsShippings()
    {
        return isset($this->otherUsShippings) ? $this->otherUsShippings : null;
    }
    /**
     * Set otherUsShippings value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OtherUsShipping[] $otherUsShippings
     * @return \StructType\ShippingData
     */
    public function setOtherUsShippings(array $otherUsShippings = array())
    {
        foreach ($otherUsShippings as $shippingDataOtherUsShippingsItem) {
            // validation for constraint: itemType
            if (!$shippingDataOtherUsShippingsItem instanceof \StructType\OtherUsShipping) {
                throw new \InvalidArgumentException(sprintf('The otherUsShippings property can only contain items of \StructType\OtherUsShipping, "%s" given', is_object($shippingDataOtherUsShippingsItem) ? get_class($shippingDataOtherUsShippingsItem) : gettype($shippingDataOtherUsShippingsItem)), __LINE__);
            }
        }
        if (is_null($otherUsShippings) || (is_array($otherUsShippings) && empty($otherUsShippings))) {
            unset($this->otherUsShippings);
        } else {
            $this->otherUsShippings = $otherUsShippings;
        }
        return $this;
    }
    /**
     * Add item to otherUsShippings value
     * @throws \InvalidArgumentException
     * @param \StructType\OtherUsShipping $item
     * @return \StructType\ShippingData
     */
    public function addToOtherUsShippings(\StructType\OtherUsShipping $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OtherUsShipping) {
            throw new \InvalidArgumentException(sprintf('The otherUsShippings property can only contain items of \StructType\OtherUsShipping, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->otherUsShippings[] = $item;
        return $this;
    }
    /**
     * Get overNight value
     * @return float|null
     */
    public function getOverNight()
    {
        return $this->overNight;
    }
    /**
     * Set overNight value
     * @param float $overNight
     * @return \StructType\ShippingData
     */
    public function setOverNight($overNight = null)
    {
        $this->overNight = $overNight;
        return $this;
    }
    /**
     * Get secondDayCost value
     * @return float|null
     */
    public function getSecondDayCost()
    {
        return $this->secondDayCost;
    }
    /**
     * Set secondDayCost value
     * @param float $secondDayCost
     * @return \StructType\ShippingData
     */
    public function setSecondDayCost($secondDayCost = null)
    {
        $this->secondDayCost = $secondDayCost;
        return $this;
    }
    /**
     * Get shippingCostDatas value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ShippingCostData[]|null
     */
    public function getShippingCostDatas()
    {
        return isset($this->shippingCostDatas) ? $this->shippingCostDatas : null;
    }
    /**
     * Set shippingCostDatas value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ShippingCostData[] $shippingCostDatas
     * @return \StructType\ShippingData
     */
    public function setShippingCostDatas(array $shippingCostDatas = array())
    {
        foreach ($shippingCostDatas as $shippingDataShippingCostDatasItem) {
            // validation for constraint: itemType
            if (!$shippingDataShippingCostDatasItem instanceof \StructType\ShippingCostData) {
                throw new \InvalidArgumentException(sprintf('The shippingCostDatas property can only contain items of \StructType\ShippingCostData, "%s" given', is_object($shippingDataShippingCostDatasItem) ? get_class($shippingDataShippingCostDatasItem) : gettype($shippingDataShippingCostDatasItem)), __LINE__);
            }
        }
        if (is_null($shippingCostDatas) || (is_array($shippingCostDatas) && empty($shippingCostDatas))) {
            unset($this->shippingCostDatas);
        } else {
            $this->shippingCostDatas = $shippingCostDatas;
        }
        return $this;
    }
    /**
     * Add item to shippingCostDatas value
     * @throws \InvalidArgumentException
     * @param \StructType\ShippingCostData $item
     * @return \StructType\ShippingData
     */
    public function addToShippingCostDatas(\StructType\ShippingCostData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ShippingCostData) {
            throw new \InvalidArgumentException(sprintf('The shippingCostDatas property can only contain items of \StructType\ShippingCostData, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->shippingCostDatas[] = $item;
        return $this;
    }
    /**
     * Get shippingService value
     * @return string|null
     */
    public function getShippingService()
    {
        return $this->shippingService;
    }
    /**
     * Set shippingService value
     * @uses \EnumType\ShippingServices::valueIsValid()
     * @uses \EnumType\ShippingServices::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $shippingService
     * @return \StructType\ShippingData
     */
    public function setShippingService($shippingService = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ShippingServices::valueIsValid($shippingService)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $shippingService, implode(', ', \EnumType\ShippingServices::getValidValues())), __LINE__);
        }
        $this->shippingService = $shippingService;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ShippingData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
