<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for stretcherBar StructType
 * @subpackage Structs
 */
class StretcherBar extends ExternalProduct
{
    /**
     * The height
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $height;
    /**
     * The storeAssemble
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var bool
     */
    public $storeAssemble;
    /**
     * The width
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $width;
    /**
     * Constructor method for stretcherBar
     * @uses StretcherBar::setHeight()
     * @uses StretcherBar::setStoreAssemble()
     * @uses StretcherBar::setWidth()
     * @param float $height
     * @param bool $storeAssemble
     * @param float $width
     */
    public function __construct($height = null, $storeAssemble = null, $width = null)
    {
        $this
            ->setHeight($height)
            ->setStoreAssemble($storeAssemble)
            ->setWidth($width);
    }
    /**
     * Get height value
     * @return float|null
     */
    public function getHeight()
    {
        return $this->height;
    }
    /**
     * Set height value
     * @param float $height
     * @return \StructType\StretcherBar
     */
    public function setHeight($height = null)
    {
        $this->height = $height;
        return $this;
    }
    /**
     * Get storeAssemble value
     * @return bool|null
     */
    public function getStoreAssemble()
    {
        return $this->storeAssemble;
    }
    /**
     * Set storeAssemble value
     * @param bool $storeAssemble
     * @return \StructType\StretcherBar
     */
    public function setStoreAssemble($storeAssemble = null)
    {
        $this->storeAssemble = $storeAssemble;
        return $this;
    }
    /**
     * Get width value
     * @return float|null
     */
    public function getWidth()
    {
        return $this->width;
    }
    /**
     * Set width value
     * @param float $width
     * @return \StructType\StretcherBar
     */
    public function setWidth($width = null)
    {
        $this->width = $width;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StretcherBar
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
