<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for template StructType
 * @subpackage Structs
 */
class Template extends ExternalProduct
{
    /**
     * The variables
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TemplateVariable[]
     */
    public $variables;
    /**
     * Constructor method for template
     * @uses Template::setVariables()
     * @param \StructType\TemplateVariable[] $variables
     */
    public function __construct(array $variables = array())
    {
        $this
            ->setVariables($variables);
    }
    /**
     * Get variables value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TemplateVariable[]|null
     */
    public function getVariables()
    {
        return isset($this->variables) ? $this->variables : null;
    }
    /**
     * Set variables value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TemplateVariable[] $variables
     * @return \StructType\Template
     */
    public function setVariables(array $variables = array())
    {
        foreach ($variables as $templateVariablesItem) {
            // validation for constraint: itemType
            if (!$templateVariablesItem instanceof \StructType\TemplateVariable) {
                throw new \InvalidArgumentException(sprintf('The variables property can only contain items of \StructType\TemplateVariable, "%s" given', is_object($templateVariablesItem) ? get_class($templateVariablesItem) : gettype($templateVariablesItem)), __LINE__);
            }
        }
        if (is_null($variables) || (is_array($variables) && empty($variables))) {
            unset($this->variables);
        } else {
            $this->variables = $variables;
        }
        return $this;
    }
    /**
     * Add item to variables value
     * @throws \InvalidArgumentException
     * @param \StructType\TemplateVariable $item
     * @return \StructType\Template
     */
    public function addToVariables(\StructType\TemplateVariable $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TemplateVariable) {
            throw new \InvalidArgumentException(sprintf('The variables property can only contain items of \StructType\TemplateVariable, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->variables[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Template
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
