<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for validatePaymentMethods StructType
 * Meta informations extracted from the WSDL
 * - type: tns:validatePaymentMethods
 * @subpackage Structs
 */
class ValidatePaymentMethods extends AbstractStructBase
{
    /**
     * The paymentMethods
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PaymentMethod[]
     */
    public $paymentMethods;
    /**
     * Constructor method for validatePaymentMethods
     * @uses ValidatePaymentMethods::setPaymentMethods()
     * @param \StructType\PaymentMethod[] $paymentMethods
     */
    public function __construct(array $paymentMethods = array())
    {
        $this
            ->setPaymentMethods($paymentMethods);
    }
    /**
     * Get paymentMethods value
     * @return \StructType\PaymentMethod[]|null
     */
    public function getPaymentMethods()
    {
        return $this->paymentMethods;
    }
    /**
     * Set paymentMethods value
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentMethod[] $paymentMethods
     * @return \StructType\ValidatePaymentMethods
     */
    public function setPaymentMethods(array $paymentMethods = array())
    {
        foreach ($paymentMethods as $validatePaymentMethodsPaymentMethodsItem) {
            // validation for constraint: itemType
            if (!$validatePaymentMethodsPaymentMethodsItem instanceof \StructType\PaymentMethod) {
                throw new \InvalidArgumentException(sprintf('The paymentMethods property can only contain items of \StructType\PaymentMethod, "%s" given', is_object($validatePaymentMethodsPaymentMethodsItem) ? get_class($validatePaymentMethodsPaymentMethodsItem) : gettype($validatePaymentMethodsPaymentMethodsItem)), __LINE__);
            }
        }
        $this->paymentMethods = $paymentMethods;
        return $this;
    }
    /**
     * Add item to paymentMethods value
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentMethod $item
     * @return \StructType\ValidatePaymentMethods
     */
    public function addToPaymentMethods(\StructType\PaymentMethod $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaymentMethod) {
            throw new \InvalidArgumentException(sprintf('The paymentMethods property can only contain items of \StructType\PaymentMethod, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->paymentMethods[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ValidatePaymentMethods
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
